library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;
use work.gbt_bank_package.all;
use work.vendor_specific_gbt_bank_package.all;

entity rx_gearbox_tb is

end rx_gearbox_tb;

architecture Behavior of rx_gearbox_tb is

signal reset : std_logic := '1';
signal clk : std_logic := '0';
signal clken : std_logic := '0';
signal header : std_logic := '0';
signal ready : std_logic := '0';
signal cnt : std_logic_vector(3 downto 0) := (others => '0');
signal sr : std_logic_vector(gbt_word_ratio-1 downto 0) := (others => '0');
signal RX_Word : std_logic_vector(word_width-1 downto 0) := (others => '0');
signal RX_FRAME : std_logic_vector(119 downto 0);
begin
utt : ENTITY work.gbt_rx_gearbox
        ------------------------------------------------------------------------------
			PORT MAP (
				rx_reset_I                            => reset,
				RX_wordCLK_i                      		=> clk,
--				RX_frameCLK_i                      		=> '0',
--				rx_CLKEN_i                     		=> '0',
--				rx_CLKEN_o                     	=> clken,
				RX_HEADERFLAG_i           => header,
				READY_O                        => ready,
				RX_WORD_I                           => RX_WORD,
				RX_FRAME_O	 	                    		=> RX_FRAME
				);
clk <= not clk after 5ns;
process(clk)
begin
	if(clk'event and clk = '1')then
	 if(cnt = "1011")then
	   cnt <= "0000";
	   header <= '1';
	 else
	   cnt <= cnt + 1;
	   header <= '0';
	 end if;
	 if(header = '1')then
	 	sr <= (others => '0');
	 	sr(0) <= '1';
	 else
	 	sr <= sr(gbt_word_ratio-2 downto 0) & sr(gbt_word_ratio-1);
	 end if;
	 rx_word <= rx_word + 1;
	end if;
end process;  
stim_proc: process
          begin    
             -- hold reset state for 100 ns.
             wait for 150 ns;  
             reset <= '0';
             wait;
          end process;
end Behavior;
