library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;
use work.gbt_bank_package.all;
use work.vendor_specific_gbt_bank_package.all;

entity tx_gearbox_tb is

end tx_gearbox_tb;

architecture Behavior of tx_gearbox_tb is

signal reset : std_logic := '1';
signal gbt_tx_reset : std_logic := '0';
signal drpclk : std_logic := '0';
signal clk : std_logic := '1';
signal fclk : std_logic := '0';
signal clken : std_logic := '0';
signal ready : std_logic := '0';
signal cnt : std_logic_vector(3 downto 0) := (others => '0');
signal TX_Word : std_logic_vector(WORD_WIDTH-1 downto 0) := (others => '0');
signal TX_FRAME : std_logic_vector(119 downto 0) := (others => '0');
begin
utt : ENTITY work.gbt_tx_gearbox
	generic map(TX_OPTIMIZATION => STANDARD)
--	generic map(TX_OPTIMIZATION => LATENCY_OPTIMIZED)
        ------------------------------------------------------------------------------
			PORT MAP (
				tx_reset_I                            => gbt_tx_reset,
				tX_wordCLK_i                      		=> clk,
				tX_frameCLK_i                      		=> fclk,
				tx_CLKEN_i                     		=> clken,
				tx_PHALIGNED_O                        => open,
				tx_PHCOMPUTED_O                        => open,
				TX_WORD_O                           => TX_WORD,
				TX_FRAME_I	 	                    		=> TX_FRAME
				);
drpclk <= not drpclk after 9ns;
clk <= not clk after 5ns;
fclk <= not fclk after 15ns;
process(clk)
begin
	if(clk'event and clk = '1')then
	 if(cnt = "1011")then
	   cnt <= "0000";
	 else
	   cnt <= cnt + 1;
	 end if;
	end if;
end process;  
			 gbtBank_gbtBankRst: entity work.gbt_bank_reset    
					 generic map (
							 INITIAL_DELAY                          => 10
					 )
					 port map (
							 GBT_CLK_I                              => drpclk,
							 TX_FRAMECLK_I                          => fclk,
							 TX_CLKEN_I                             => clken,
							 RX_FRAMECLK_I                          => '0',
							 RX_CLKEN_I                             => '0',
							 MGTCLK_I                               => drpclk,
							 
							 --===============--  
							 -- Resets scheme --  
							 --===============--  
							 GENERAL_RESET_I                        => reset,
							 TX_RESET_I                             => '0',
							 RX_RESET_I                             => '0',
							 
							 MGT_TX_RESET_O                         => open,
							 MGT_RX_RESET_O                         => open,
							 GBT_TX_RESET_O                         => gbt_tx_reset,
							 GBT_RX_RESET_O                         => open,

							 MGT_TX_RSTDONE_I                       => '1',
							 MGT_RX_RSTDONE_I                       => '1'                                                                    
					 ); 
process(fclk)
begin
	if(fclk'event and fclk = '1')then
		if(WORD_WIDTH = 40)then
			clken <= '1';
		else
	   clken <= not clken;
	  end if;
	  if(clken = '1')then
	    tx_frame <= tx_frame + 1;
	  end if;
	end if;
end process;  
stim_proc: process
          begin    
             -- hold reset state for 100 ns.
             wait for 151 ns;  
             reset <= '0';
             wait;
          end process;
end Behavior;
