----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 03/16/2017 06:36:20 PM
-- Design Name: 
-- Module Name: clk_divide3 - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity clk_divide3 is
    Port ( clk_i : in STD_LOGIC;
           reset_i : in STD_LOGIC;
           refclk_i : in STD_LOGIC;
           clk_o : out STD_LOGIC
			  );
end clk_divide3;

architecture Behavioral of clk_divide3 is

signal pos_cnt : integer range 0 to 2;
signal neg_cnt : integer range 0 to 2;
signal pos_edge : STD_LOGIC := '0';
begin
     process(clk_i, reset_i) is
     begin
        if rising_edge(clk_i) then
			if reset_i = '1' then
				pos_cnt <= 0;
			elsif neg_cnt = 0 then
                pos_cnt <= 0;
            else
                pos_cnt <= pos_cnt + 1;
            end if;
        end if;
     end process;
     
     process(clk_i, reset_i) is
     begin
        if falling_edge(clk_i) then
            pos_edge <= refclk_i;
			if reset_i = '1' then
				neg_cnt <= 0;
            elsif pos_edge = '0' and refclk_i = '1' then
                neg_cnt <= 0;
            else
                neg_cnt <= neg_cnt + 1;
            end if;
        end if;
     end process;
     
     clk_o <= '1' when (pos_cnt /= 2 and neg_cnt /= 2) else '0';

end Behavioral;
