----------------------------------------------------------------------------------
-- Company: 
-- Engineer: SAHIN
-- 
-- Create Date:    16:12:28 08/07/2012 
-- Design Name: 
-- Module Name:    RAM_module - Behavioral 
-- Project Name: 
-- Target Devices: FC7
-- Tool versions: 
-- Description: 
--  block ram inst for partitions
-- Dependencies: 
--
-- Revision: 
-- Revision 1.00 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use work.ngFEC_pack.all;
Library UNISIM;
use UNISIM.vcomponents.all;
Library UNIMACRO;
use UNIMACRO.vcomponents.all;
 entity Module_RAM is 
 port (   --  Port A    
 a_clk   : in  std_logic;
 a_wr    : in  std_logic_VECTOR(0 DOWNTO 0);
 a_addr  : in  std_logic_vector(BRAM_WORD_SIZE downto 0); 
 a_din   : in  std_logic_vector(31 downto 0); 
 a_dout  : out std_logic_vector(31 downto 0); 
 a_aout  : out std_logic_vector(BRAM_WORD_SIZE downto 0);       
 

 -- Port B   

 b_clk   : in  std_logic;  
 b_wr    : in  std_logic_VECTOR(0 DOWNTO 0);  
 b_addr  : in  std_logic_vector(BRAM_WORD_SIZE downto 0);  
 b_din   : in  std_logic_vector(31 downto 0); 
 b_dout  : out std_logic_vector(31 downto 0);
 b_aout  : out std_logic_vector(BRAM_WORD_SIZE downto 0));

end Module_RAM; 

architecture Behavioral of Module_RAM is 
signal  DOA_l : std_logic_vector(31 downto 0) := (others=>'0'); 
signal  DOA_h : std_logic_vector(31 downto 0) := (others=>'0'); 
signal  DOB_l : std_logic_vector(31 downto 0) := (others=>'0'); 
signal  DOB_h : std_logic_vector(31 downto 0) := (others=>'0'); 
signal  wea : std_logic_vector(3 downto 0) := (others=>'0'); 
signal  web : std_logic_vector(3 downto 0) := (others=>'0'); 
signal  ENA_l : std_logic := '0'; 
signal  ENA_h : std_logic := '0'; 
signal  sel_ah : std_logic := '0'; 
signal  ENB_l : std_logic := '0'; 
signal  ENB_h : std_logic := '0'; 
signal  sel_bh : std_logic := '0'; 
--	COMPONENT bram
--	PORT (
--    clka  : IN STD_LOGIC;
--    wea   : IN STD_LOGIC_VECTOR(0 DOWNTO 0);
--    addra : IN STD_LOGIC_VECTOR(BRAM_WORD_SIZE DOWNTO 0);
--    dina  : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
--    douta : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
--    clkb  : IN STD_LOGIC;
--    web   : IN STD_LOGIC_VECTOR(0 DOWNTO 0);
--    addrb : IN STD_LOGIC_VECTOR(BRAM_WORD_SIZE DOWNTO 0);
--    dinb  : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
--    doutb : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
--	);
--	END COMPONENT;
	begin 
	delay:process(a_clk) begin
	if(rising_edge(a_clk)) then 
			if b_wr = "0" then
				b_aout <= b_addr;
			end if;
			if a_wr = "0" then
				a_aout <= a_addr;
			end if;
	end if;
	end process;
wea <= x"f" when a_wr = "1" else x"0";
web <= x"f" when b_wr = "1" else x"0";
ENA_l <= '1' when a_addr(BRAM_WORD_SIZE) = '0' else '0';
ENB_l <= '1' when b_addr(BRAM_WORD_SIZE) = '0' else '0';
ENA_h <= '1' when a_addr(BRAM_WORD_SIZE downto BRAM_WORD_SIZE-1) = "10" else '0';
ENB_h <= '1' when b_addr(BRAM_WORD_SIZE downto BRAM_WORD_SIZE-1) = "10" else '0';
process(a_clk)
begin
	if(a_clk'event and a_clk = '1')then
		sel_ah <= a_addr(BRAM_WORD_SIZE);
	end if;
end process;
process(b_clk)
begin
	if(b_clk'event and b_clk = '1')then
		sel_bh <= b_addr(BRAM_WORD_SIZE);
	end if;
end process;
a_dout <= DOA_l when sel_ah = '0' else DOA_h;
b_dout <= DOb_l when sel_bh = '0' else DOB_h;
bram_gen: for i in 0 to 1 generate
   BRAM_l : BRAM_TDP_MACRO
   generic map (
      BRAM_SIZE => "36Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target device: "VIRTEX5", "VIRTEX6", "7SERIES", "SPARTAN6" 
      READ_WIDTH_A => 16,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH_B => 16,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      WRITE_WIDTH_A => 16, -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      WRITE_WIDTH_B => 16) -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
   port map (
      DOA => DOA_l(i*16+15 downto i*16),       -- Output port-A data, width defined by READ_WIDTH_A parameter
      DOB => DOB_l(i*16+15 downto i*16),       -- Output port-B data, width defined by READ_WIDTH_B parameter
      ADDRA => a_addr(10 downto 0),   -- Input port-A address, width defined by Port A depth
      ADDRB => b_addr(10 downto 0),   -- Input port-B address, width defined by Port B depth
      CLKA => a_clk,     -- 1-bit input port-A clock
      CLKB => b_clk,     -- 1-bit input port-B clock
      DIA => a_din(i*16+15 downto i*16),       -- Input port-A data, width defined by WRITE_WIDTH_A parameter
      DIB => b_din(i*16+15 downto i*16),       -- Input port-B data, width defined by WRITE_WIDTH_B parameter
      ENA => ENA_l,       -- 1-bit input port-A enable
      ENB => ENB_l,       -- 1-bit input port-B enable
      REGCEA => '1', -- 1-bit input port-A output register enable
      REGCEB => '1', -- 1-bit input port-B output register enable
      RSTA => '0',     -- 1-bit input port-A reset
      RSTB => '0',     -- 1-bit input port-B reset
      WEA => wea(1 downto 0),       -- Input port-A write enable, width defined by Port A depth
      WEB => web(1 downto 0)        -- Input port-B write enable, width defined by Port B depth
   );
end generate;
BRAM_h : BRAM_TDP_MACRO
   generic map (
      BRAM_SIZE => "36Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target device: "VIRTEX5", "VIRTEX6", "7SERIES", "SPARTAN6" 
      READ_WIDTH_A => 32,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH_B => 32,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      WRITE_WIDTH_A => 32, -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      WRITE_WIDTH_B => 32) -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
   port map (
      DOA => DOA_h,       -- Output port-A data, width defined by READ_WIDTH_A parameter
      DOB => DOB_h,       -- Output port-B data, width defined by READ_WIDTH_B parameter
      ADDRA => a_addr(9 downto 0),   -- Input port-A address, width defined by Port A depth
      ADDRB => b_addr(9 downto 0),   -- Input port-B address, width defined by Port B depth
      CLKA => a_clk,     -- 1-bit input port-A clock
      CLKB => b_clk,     -- 1-bit input port-B clock
      DIA => a_din,       -- Input port-A data, width defined by WRITE_WIDTH_A parameter
      DIB => b_din,       -- Input port-B data, width defined by WRITE_WIDTH_B parameter
      ENA => ENA_h,       -- 1-bit input port-A enable
      ENB => ENB_h,       -- 1-bit input port-B enable
      REGCEA => '1', -- 1-bit input port-A output register enable
      REGCEB => '1', -- 1-bit input port-B output register enable
      RSTA => '0',     -- 1-bit input port-A reset
      RSTB => '0',     -- 1-bit input port-B reset
      WEA => wea,       -- Input port-A write enable, width defined by Port A depth
      WEB => web        -- Input port-B write enable, width defined by Port B depth
   );
--	mem:  bram
--	PORT MAP (
--    clka  => a_clk,
--    wea   => a_wr,
--    addra => a_addr,
--    dina  => a_din,
--    douta => a_dout,  
--	 clkb  => b_clk,
--    web   => b_wr,
--    addrb => b_addr,
--    dinb  => b_din,
--    doutb => b_dout
--	);
 end Behavioral;
